﻿package
{
	import flash.utils.Timer;
	import flash.utils.getTimer;
	import flash.events.Event;
	import flash.events.TimerEvent;
	import flash.display.MovieClip;

	public class GameTimer extends MovieClip
	{
		private var counter:Timer;
		private var timestemp:Number = 0;
		
		public function GameTimer()
		{	
				// Start counting when added to stage
			addEventListener(Event.ADDED_TO_STAGE, function (event:Event) {
					// If unlimited time wanted, act as a word counter
				if(ResourceManager.config.time == "unlimited") {
						// First time update
					status.text = "Words left:";
					timer.text = ResourceManager.config.words.toString();
					
						// Register to word found to decrese counter
					root.addEventListener(WordEvent.FOUND, function(event:WordEvent) {
						timer.text = String(Number(timer.text) - 1);
					});
				} else {
						// XMLLoader already converts string to milliseconds
						// Only one cycle is needed
					counter = new Timer(ResourceManager.config.time, 1);
					
						// Keep a time stemp
					timestemp = getTimer();
					
						// When timer completes, pipe message to root
					counter.addEventListener(TimerEvent.TIMER_COMPLETE, function(event:TimerEvent) {
						root.dispatchEvent(event);
					});
					
						// Start the timer
					counter.start();
				}
			});
			
				// Update text (Will not work as a word counter mode)
			addEventListener(Event.ENTER_FRAME, function(event:Event) {
				if(counter == null)
					return;
					// Check if running (stail updates)
				if(!counter.running)
					return;
					
				var milliseconds:Number = counter.delay - (getTimer() - timestemp);
					
					// Build components
				var seconds:int = (milliseconds / 1000) % 60;
				var minutes:int = (milliseconds / (1000 * 60)) % 60;
				var hours  :int =  milliseconds / (1000 * 60 * 60);
				
					// Reset text
				timer.text = "";
				
					// Only show hours of exist
				if(hours > 0)
					timer.appendText(hours + ":");
					
					// Leading zero
				if(minutes < 10)
					timer.appendText("0");
					// Minutes
				timer.appendText(minutes.toString());
				
					// Separating ':'
				timer.appendText(":");
				
					// Leading zero
				if(seconds < 10)
					timer.appendText("0");
					// Seconds
				timer.appendText(seconds.toString());
			});
		}
	}
}