﻿package  
{  
	import flash.events.Event;
	import flash.events.IOErrorEvent;
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	import flash.errors.IOError;

	public class ResourceManager  
	{
		private static var xml:XML = null;
		private static var wordArray:Array = null;
		
		public static function load(path:String)
		{
				// Can't load twice
			if(xml != null)
				return;
			
			var urlReq:URLRequest = new URLRequest(path);
			var urlLoader:URLLoader = new URLLoader(urlReq);
			
				// On complete event, copy the data over
			urlLoader.addEventListener(Event.COMPLETE, function (event:Event) {
				xml = new XML(event.target.data);
					// splice a cut if needed
				randomize();
			});
			
				// On error, throw the error message
			urlLoader.addEventListener(IOErrorEvent.IO_ERROR, function (event:IOErrorEvent) {
				throw IOError(event.text);
			});
		}
		
		public static function get dataAvailable():Boolean
		{
				// Data is available if XML was loaded
			return (xml != null);
		}
		
		public static function get words():Array
		{
				// Return a copy
			return wordArray.concat();
		}
		
		public static function get config()
		{
				// New accociative artay
			var conf:Object = new Object();
			
				// Allow horizontal placement
			conf["horizontal"] = Boolean(xml.@horizontal == "true");
			
				// Allow vertical placement
			conf["vertical"] = Boolean(xml.@vertical == "true");
			
				// Allow diagonal placement
			conf["diagonal"] = Boolean(xml.@diagonal == "true");
			
				// Allow reverse placement
			conf["reverse"] = Boolean(xml.@reverse == "true");
			
				// Number of words to shuffle from
			conf["words"] = Number(xml.@words);
			
				// Check if unlimited time wanted
			if(xml.@time != "unlimited") {
					// Convert formatted time to milliseconds
				var timeFormatted:Array = String(xml.@time).split(":").reverse(); // "hh:mm:ss -> [hh, mm, ss] -> [ss, mm, ss]
				var time:Number = 0;
				for(var i:int=0; i<timeFormatted.length; ++i)
					time += timeFormatted[i] * Math.pow(60, i);
					// Save converted time
				conf["time"] = time * 1000;
			} else
				conf["time"] = "unlimited";
			
				// Return generated object
			return conf;
		}
		
		public static function randomize()
		{
				// No data to work with
			if(!dataAvailable)
				return;
			
				// Default value is set to all
			var size:Number = xml.words.word.length();
			
				// Check if attributes words exists
			if(xml.attribute("limit").length() != 0)
				size = xml.@limit;
			
				// Construct an array of words
			wordArray = new Array();
			for each(var word in xml.words.word)
				wordArray.push(word);
				
				// Shuffle array
			for(var i:int=0; i<words.length; ++i) {
				var randCell:int = Math.floor(Math.random() * wordArray.length);
					// No XOR swap :(
				var tmp:* = wordArray[i];
				wordArray[i] = wordArray[randCell];
				wordArray[randCell] = tmp;
			}
				// Return a part of the shuffled array
			wordArray = words.splice(0, size);
		}
	}
} 
