﻿package
{
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.text.TextField;
	import flash.display.MovieClip;
	import flash.display.DisplayObject;

	public class WordList extends MovieClip
	{
		private var words:Array = new Array();
		private var labels:Array = new Array();
		
		private var wordsOffset:int = 0;
		
		public function WordList()
		{
				// Insert all words to the array
			var current:DisplayObject = getChildByName("word" + labels.length);
			while((current != null) && (current is Word)) {
				labels.push(current);
				current = getChildByName("word" + labels.length);
			}
			
				// Populate labels when added to stage
			addEventListener(Event.ADDED_TO_STAGE, function(event:Event) {
				populate();
				
					// Remove the word - message passed using root
				root.addEventListener(WordEvent.FOUND, function(event:WordEvent) {
					remove(event.word.toLowerCase());
				});
				
					// Scroll up button
				scrollUp.addEventListener(MouseEvent.CLICK, function(event:Event) {
						// Scroll up
					wordsOffset -= 1;
						// Limit
					if(wordsOffset < 0)
						wordsOffset = 0;
						// Update
					update();
				});
					// Scroll down button
				scrollDown.addEventListener(MouseEvent.CLICK, function(event:Event) {
						// Scroll down
					wordsOffset += 1;
						// Limit
					if(wordsOffset > words.length - labels.length)
						wordsOffset = words.length - labels.length;
						// Update
					update();
				});
			});
			
			addEventListener(Event.REMOVED_FROM_STAGE, function(event:Event) {
				reset();
			});
		}
		
		private function reset()
		{
				// Reset all labels
			for each(var label in labels)
				label.text = "";
		}
		
		private function populate()
		{
				// Filter and format words
			words = ResourceManager.words.map(function(item:*) {
					// Format words nicely ("Formal")
				var word:String = item.split(" ").join("").toLowerCase();
				return word.charAt(0).toUpperCase() + word.substr(1);
			}).filter(function(item:*, index:int, array:Array):Boolean {
				return (array.indexOf(item, index + 1) == -1);
			});
				
				// Fill up until we run out of space
			update();
		}
		
		private function update()
		{
				// Reset all labels
			reset();
			
				// update alive words
			for(var i:int=0; i<Math.min(words.length, labels.length); ++i)
				labels[i].text = words[i + wordsOffset];
				
				// Hide buttons if there are enough places to display words
			if(words.length <= labels.length) {
				scrollUp.visible = false;
				scrollDown.visible = false;
			}
		}
		
		private function remove(word:String)
		{
			var index:int = words.map(function(item:*) {
					// Convert all to upper case for comparison (Formal to UPPER)
				return item.toLowerCase();
			}).indexOf(word.toLowerCase());

				// Remove word from list
			words.splice(index, 1);
				
				// Update the labels
			update();
		}
	}
}